public class BinaryStringTree {

    class Node {

        final String value;
        Node left;
        Node right;

        Node(String s) {
            value = s;
            left = right = null;
        }
    }

    private Node root;
    private int counter;

    public BinaryStringTree() {
        root = null;
    }

    private void insert(String s, Node node) {
        if (node.value.compareTo(s) > 0) {
            if (node.left == null) {
                node.left = new Node(s);
            } else {
                insert(s, node.left);
            }
        } else {
            if (node.right == null) {
                node.right = new Node(s);
            } else {
                insert(s, node.right);
            }
        }
    }

    public void insert(String s) {
        if (root == null) {
            root = new Node(s);
        } else {
            insert(s, root);
        }
    }

    private void traverse(Node node) {
        if (node != null) {
            if (node.left != null) {
                traverse(node.left);
            }
            System.out.print(counter + ": " + node.value + " ");
            counter++;
            if (node.right != null) {
                traverse(node.right);
            }
        }
    }

    public void traverse() {
        counter = 0;
        traverse(root);
    }

}
