public class PriorityQueueLinkedListNaive implements PriorityQueue {

    private class ListNode {

        Comparable item;
        ListNode next;

        ListNode(Comparable item) {
            this.item = item;
            next = null;
        }
    }

    private ListNode start;

    public PriorityQueueLinkedListNaive() {
        start = null;
    }

    @Override
    public Comparable push(Comparable item) {
        if (item == null) {
            throw new RuntimeException("Adding null o PriorityQueue not allowed");
        }
        ListNode node = new ListNode(item);
        if (start == null) {
            start = node;
        } else {
            node.next = start;
            start = node;
        }
        return item;
    }

    @Override
    public Comparable pop() {
        if (start == null) {
            return null;
        }

        ListNode prevRet = null; //remember the previous of the ret
        ListNode ret = start;
        ListNode prev = start;
        ListNode cur = start.next;
        while (cur != null) {
            if (cur.item.compareTo(ret.item) < 0) {
                ret = cur;
                prevRet = prev;
            }
            prev = cur;
            cur = cur.next;
        }
        if (prevRet == null) {
            start = start.next;
        } else {
            prevRet.next = ret.next;
        }
        return ret.item;
    }

    @Override
    public Comparable peek() {
        if (start == null) {
            return null;
        }
        ListNode ret = start;
        ListNode cur = start.next;
        while (cur != null) {
            if (cur.item.compareTo(ret.item) < 0) {
                ret = cur;
            }
            cur = cur.next;
        }
        return ret.item;
    }

    @Override
    public boolean isEmpty() {
        return start == null;
    }

}
