public class QueueLinkedList implements Queue {

    private class ListNode {

        Object item;
        ListNode next;

        ListNode(Object item) {
            this.item = item;
            next = null;
        }
    }

    private ListNode start;
    private ListNode end;

    public QueueLinkedList() {
        start = end = null;
    }

    @Override
    public Object push(Object item) {
        ListNode node = new ListNode(item);
        if (start == null) {
            start = end = node;
        } else {
            end.next = node;
            end = end.next;
        }
        return item;
    }

    @Override
    public Object pop() {
        if (start == null) {
            throw new RuntimeException("Queue empty");
        }
        Object ret = start.item;
        start = start.next;
        if (start == null) {
            end = null;
        }
        return ret;
    }

    @Override
    public boolean isEmpty() {
        return start == null;
    }

    @Override
    public Object peek() {
        return start != null ? start.item : null;
    }

    @Override
    public Object back() {
        return end != null ? end.item : null;
    }

}
