public interface Stack {

    /**
     * Add the item if it is not null
     *
     * @param item
     * @return the added item or null if object has not been added to the stack
     */
    public Object push(Object item);

    /**
     * Remote the top item from the stack if the stack is not empty
     *
     * @return the current top item or null if it is empty
     */
    public Object pop();

    /**
     *
     * @return true if stack is not empty
     */
    public boolean isEmpty();

    /**
     * Return the top item but it does not remove it from the stack
     *
     * @return the current top item from the stack or null if stack is empty
     */
    public Object peek();
}
