public class StackLinkedList implements Stack {

    private class ListNode {

        Object item;
        ListNode next;

        ListNode(Object item) {
            this.item = item;
            next = null;
        }
    }
    private ListNode start;

    public StackLinkedList() {
        start = null;
    }

    @Override
    public Object push(Object item) {
        if (item == null) {
            return null;
        }
        ListNode node = new ListNode(item);
        if (start == null) {
            start = node;
        } else {
            node.next = start;
            start = node;
        }
        return item;
    }

    @Override
    public Object pop() {
        Object ret = null;
        if (start != null) {
            ret = start.item;
            start = start.next;
        }
        return ret;
    }

    @Override
    public boolean isEmpty() {
        return start == null;
    }

    @Override
    public Object peek() {
        return start != null ? start.item : null;
    }

}
