public class StackResizeArray implements Stack {

    private final int RESIZE = 10;
    private Object[] stack;
    private int count;

    public StackResizeArray() {
        stack = new Object[RESIZE];
        count = 0;
    }

    @Override
    public Object push(Object item) {
        if (item == null) {
            return null;
        }
        if (count == stack.length) {
            Object[] newStack = new Object[stack.length + RESIZE];
            System.arraycopy(stack, 0, newStack, 0, stack.length);
            stack = newStack;
        }
        return stack[count++] = item;
    }

    @Override
    public Object pop() {
        return count > 0 ? stack[--count] : null;
    }

    @Override
    public boolean isEmpty() {
        return count == 0;
    }

    @Override
    public Object peek() {
        return count > 0 ? stack[count - 1] : null;
    }

}
